//+------------------------------------------------------------------+
//|                                        Indicator: Samuelkanu.mq4 |
//|                                 Created by JeremyXxLESSOxXLester |
//|                                            lesso88@gmail.com.com |
//+------------------------------------------------------------------+
#property copyright "Created by JeremyXxLESSOxXLester"
#property link      "lesso88@gmail.com"
#property version   "1.00"
#property description ""

#include <stdlib.mqh>
#include <stderror.mqh>

//--- indicator settings
#property indicator_chart_window
#property indicator_buffers 2

#property indicator_type1 DRAW_ARROW
#property indicator_width1 1
#property indicator_color1 0xFFAA00
#property indicator_label1 "Buy"

#property indicator_type2 DRAW_ARROW
#property indicator_width2 1
#property indicator_color2 0x0000FF
#property indicator_label2 "Sell"

//--- indicator buffers
double Buffer1[];
double Buffer2[];

extern int ADXPeriod = 14;
extern int maPeriod1 = 10;
extern int maPeriod2 = 20;
extern double arrowdistanceX = 25;
extern bool            alertsOn        = false;
extern bool            alertsOnCurrent = true;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = false;
extern bool            alertsNotify    = false;
extern bool            alertsEmail     = false;
extern string          soundFile       = "alert2.wav";
double myPoint; //initialized in OnInit

void myAlert(string type, string message)
  {
   if(type == "print")
      Print(message);
   else if(type == "error")
     {
      Print(type+" | Samuelkanu @ "+Symbol()+","+Period()+" | "+message);
     }
   else if(type == "order")
     {
     }
   else if(type == "modify")
     {
     }
  }

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {   
   IndicatorBuffers(2);
   SetIndexBuffer(0, Buffer1);
   SetIndexArrow(0, 241);
   SetIndexBuffer(1, Buffer2);
   SetIndexArrow(1, 242);
   //initialize myPoint
   myPoint = Point();
   if(Digits() == 5 || Digits() == 3)
     {
      myPoint *= 10;
     }
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
  {
   int limit = rates_total - prev_calculated;
   //--- counting from 0 to rates_total
   ArraySetAsSeries(Buffer1, true);
   ArraySetAsSeries(Buffer2, true);
   //--- initial zero
   if(prev_calculated < 1)
     {
      ArrayInitialize(Buffer1, 0);
      ArrayInitialize(Buffer2, 0);
     }
   else
      limit++;
   
   //--- main loop
   for(int i = limit-1; i >= 0; i--)
     {
      if (i >= MathMin(5000-1, rates_total-1-50)) continue; //omit some old rates to prevent "Array out of range" or slow calculation   
      //Indicator Buffer 1
      Buffer1[i] = EMPTY_VALUE;
      Buffer2[i] = EMPTY_VALUE;
      if(iMA(NULL, PERIOD_CURRENT, maPeriod1, 0, MODE_EMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, maPeriod2, 0, MODE_EMA, PRICE_CLOSE, i)
      && iMA(NULL, PERIOD_CURRENT, maPeriod1, 0, MODE_EMA, PRICE_CLOSE, i+1) < iMA(NULL, PERIOD_CURRENT, maPeriod2, 0, MODE_EMA, PRICE_CLOSE, i+1) //Moving Average crosses above Moving Average
      && iCustom(NULL, PERIOD_CURRENT, "ADX", ADXPeriod, 0, i) > iCustom(NULL, PERIOD_CURRENT, "ADX", ADXPeriod, 2, i) //ADX > ADX
      )
        {
         Buffer1[i] = Low[i] - arrowdistanceX * myPoint; //Set indicator value at Candlestick Low - fixed value
        }
      //Indicator Buffer 2
      if(iMA(NULL, PERIOD_CURRENT, maPeriod1, 0, MODE_EMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, maPeriod2, 0, MODE_EMA, PRICE_CLOSE, i)
      && iMA(NULL, PERIOD_CURRENT, maPeriod1, 0, MODE_EMA, PRICE_CLOSE, i+1) > iMA(NULL, PERIOD_CURRENT, maPeriod2, 0, MODE_EMA, PRICE_CLOSE, i+1) //Moving Average crosses below Moving Average
      && iCustom(NULL, PERIOD_CURRENT, "ADX", ADXPeriod, 0, i) < iCustom(NULL, PERIOD_CURRENT, "ADX", ADXPeriod, 2, i) //ADX < ADX
      )
        {
         Buffer2[i] = High[i] + arrowdistanceX * myPoint; //Set indicator value at Candlestick High + fixed value
        }
     }
     
     if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;  
      
      //
      //
      //
      //
      //
      
      if (Buffer1[whichBar+1] == EMPTY_VALUE && Buffer1[whichBar] != EMPTY_VALUE) doAlert(whichBar,"buy");
      if (Buffer2[whichBar+1] == EMPTY_VALUE && Buffer2[whichBar] != EMPTY_VALUE) doAlert(whichBar,"sell");
    }         
   return(rates_total);
  }
//+------------------------------------------------------------------+


//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Samuelkanu : ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Samuelkanu "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

